#include <stdio.h>

#include <vector>
#include <math.h>
#include <string.h>
#include <algorithm>
#include <string>
#include <map>

using namespace std;
struct Node {
	Node* p, *pp = 0, *c[2];
	bool flip = 0;
	Node() { c[0] = c[1] = 0; fix();}
	void fix() {
		if(c[0]) c[0]->p = this;
		if(c[1]) c[1]->p = this;
	}
	void push_flip() {
		if(!flip) return;
		flip = 0; swap(c[0], c[1]);
		if(c[0]) c[0]->flip ^= 1;
		if(c[1]) c[1]->flip ^= 1;
	}
	int up() { return p ? p->c[1] == this : -1; }
	void rot(int i, int b) {
		int h = i^b;
		Node* x = c[i], *y = b == 2 ? x : x->c[h], *z = b ? y : x;
		if((y->p = p)) p->c[up()] = y;
		c[i] = z->c[i^1];
		if(b < 2) {
			x->c[h] = y->c[h^1];
			z->c[h^1] = b ? x : this;
		}
		y->c[i^1] = b ? this : x;
		fix(); x->fix(); y->fix();
		if(p) p->fix();
		swap(pp, y->pp);
	}
	void splay() {
		for(push_flip(); p;) {
			if(p->p) p->p->push_flip();
			p->push_flip(); push_flip();
			int c1 = up(), c2 = p->up();
			if(c2 == -1) p->rot(c1, 2);
			else p->p->rot(c2, c1 != c2);
		}
	}
	Node* first() {
		push_flip();
		return c[0] ? c[0]->first() : (splay(), this);
	}
};

struct LinkCut {
	vector<Node> node;
	LinkCut(int N) : node(N) {}
	void link(int u, int v) {
		assert(!connected(u, v));
		make_root(&node[u]);
		node[u].pp = &node[v];
	}
	void cut(int u, int v) {
		Node* x = &node[u], *top = &node[v];
		make_root(top); x->splay();
		assert(top == (x->pp ?: x->c[0]));
		if(x->pp) x->pp = 0;
		else {
			x->c[0] = top->p = 0;
			x->fix();
		}
	}
	bool connected(int u, int v) {
		Node* nu = access(&node[u])->first;
		return nu == access(&node[v])->first;
	}
	void make_root(Node* u) {
		access(u);
		u->splay();
		if(u->c[0]) {
			u->c[0]->p = 0;
			u->c[0]->flip ^= 1;
			u->c[0]->pp = u;
			u->c[0] = 0;
			u->fix();
		}
	}
	Node* access(Node* u) {
		u->splay();
		while(Node* pp = u->pp) {
			pp->splay(); u->pp = 0;
			if(pp->c[1]) {
				pp->c[1]->p = 0; pp->c[1]->pp = pp;
			}
			pp->c[1] = u; pp->fix(); u = pp;
		}
		return u;
	}

}

int main()
{
	int N,Q;
	scanf("%d%d", &N, &Q);
	vector<LinkCut> levels;
	REP(i, 10) levels.pb(LinkCut(N));
	REP(qry, Q) {
		int t,x,y,v;
		scanf("%d", &t);
		if(t == 0) {
			scanf("%d%d%d", &x, &y, &v);

		}
	}

	return 0;
}
